/* FotoTimer 0.3
 * (C) 2001-2002 Hynek Sladky
 * sladky@mujmail.cz
 */

#pragma pack(2)
#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#include <System/SysEvtMgr.h>

#include "FTimRsc.h"
#include "FotoTim.h"

/*
UKOLY:
navrh:
+        mel by tam byt celkovy cas, modifikace, celkovy cas po modifikaci
+        odpocitavani celkoveho casu (staci mala pismenka)
+        odpocitavani do konce etapy, odpocitavani do dalsi casove znacky
+ obsluha menu pri editaci
*/

// forward function definitions
static int StartApplication (void);
static void EventLoop (void);
static void StopApplication (void);
static Boolean MainEventHandler (EventPtr event);
static Boolean EditEventHandler (EventPtr event);

// global variables definitions
// settings database
DmOpenRef       TimersDB;
struct sPrefs   Prefs;
struct sTimers  Timers;
char            TimersName[] = "FotoTimers";
UInt16          TPS, Ttype, Tflag, TimCnt, TimPos, OldOff, Ppos;
Int16           Tincl, Ttime, Ptime, Ptimes[Alerts];
UInt32          LastTime, TimeNow, TempStart;
FontPtr         font128;
VoidHand        fieldtext, setup[Tcnt][2], TlistHnd, paushnd, notehnd, alerthnd, valueHnd;
WinHandle       frm_win;
char            timeT[10], timeP[10], RTC[10], temp[16], eval[16], time[10], modif[10];
char            *Tnames[TimeMax];
char            TmrModes[6][12]={"START","Vvojka","Peruova","Ustalova","Pran","pauza"};
int             Toff[6]={2,5,10,15,20,30};
int             Ttemp[4]={15,30,60,120};

// Entry point
DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags) {
int error;

  if (cmd==sysAppLaunchCmdNormalLaunch) {// || cmd==Launch) {
    if (error = StartApplication()) return error;
// go to main form
    FrmGotoForm (main_form);
    EventLoop ();
    StopApplication ();
  }
  return 0;
}

// startup setup
static int StartApplication(void) {
UInt            idx;
char            *s;
LocalID         db_id;

//  if (SysLibFind ("Serial Library", &LibRef)) return 1;
// nacteni fontu
  font128=MemHandleLock(DmGetResource('nfnt', main_font));
  FntDefineFont(128, font128);
// otevreni databaze
  TimersDB=DmOpenDatabaseByTypeCreator (TimersDBType, AppID, dmModeReadWrite);
  if (!TimersDB) {
    if (DmCreateDatabase (0, TimersName, AppID, TimersDBType, false)) return 1;
    db_id=DmFindDatabase (0, TimersName);
    DmDatabaseInfo (0, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    idx|=dmHdrAttrBackup;
    DmSetDatabaseInfo (0, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    TimersDB=DmOpenDatabaseByTypeCreator (TimersDBType, AppID, dmModeReadWrite);
  }
  Tincl=Ttype=Ttime=Ptime=Tflag=0;
// nacteni preferenci
  idx=0;
  if (PrefGetAppPreferences (AppID, 0, NULL, &idx, true)!=noPreferenceFound)
    if (idx<=sizeof (struct sPrefs));
      PrefGetAppPreferences (AppID, 0, &Prefs, &idx, true);
  TimPos=Prefs.LastTimer;
// prepare list of timers
  TlistHnd=MemHandleNew ((Tnamelen+1)*TimeMax);
  s=MemHandleLock (TlistHnd);
  for (idx=0; idx<TimeMax; idx++) Tnames[idx]=&s[idx*(Tnamelen+1)];
// prepare additional memory space
  fieldtext=MemHandleNew (Tnamelen+1);
  paushnd=MemHandleNew (8);
  alerthnd=MemHandleNew (8);
  notehnd=MemHandleNew (Tnotelen+1);
  valueHnd=MemHandleNew (12);
  for (idx=0; idx<Tcnt; idx++) {
    setup[idx][0]=MemHandleNew (8);
    setup[idx][1]=MemHandleNew (8);
  }
  TPS=SysTicksPerSecond ();
  OldOff=SysSetAutoOffTime (0);
  SysSetAutoOffTime (OldOff);
  return 0;
}

// unload data, close databases, free dynamic structures
static void StopApplication (void) {
UInt            idx;
  Prefs.LastTimer=TimPos;
  PrefSetAppPreferences (AppID, 0, 0, &Prefs, sizeof (struct sPrefs), true);
  DmCloseDatabase (TimersDB);
  MemPtrUnlock (font128);
  MemHandleUnlock (TlistHnd);
  MemHandleFree (TlistHnd);
  MemHandleFree (fieldtext);
  MemHandleFree (paushnd);
  MemHandleFree (alerthnd);
  MemHandleFree (notehnd);
  MemHandleFree (valueHnd);
  for (idx=0; idx<Tcnt; idx++) {
    MemHandleFree (setup[idx][0]);
    MemHandleFree (setup[idx][1]);
  }
  SysSetAutoOffTime (OldOff);
  return;
}

// main event loop
static void EventLoop(void) {
short           err;
int             formID;
FormPtr         form;
EventType       event;

  do {
    EvtGetEvent (&event, TPS/10); // jen pro POSE!
// tohle funguje, ale jen kdyz je FotoTimer prave aktivni aplikace
    if (event.eType==keyDownEvent) {
      switch (event.data.keyDown.chr) {
	case vchrMenu:
	  if (Tflag==1) continue;
	  break;
	case vchrAutoOff:
	  SysSetAutoOffTime (OldOff);
	  break;
      }
    }

    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
    if (event.eType == frmLoadEvent) {
      formID = event.data.frmLoad.formID;
      form = FrmInitForm (formID);
      FrmSetActiveForm (form);
      switch (formID) {
      case main_form:
	FrmSetEventHandler (form, (FormEventHandlerPtr) MainEventHandler);
	break;
      case edit_form:
	FrmSetEventHandler (form, (FormEventHandlerPtr) EditEventHandler);
	break;
      }
    }
    FrmDispatchEvent (&event);
  } while (event.eType != appStopEvent);
}

// loads timer from database to memory
// mode==1
static void LoadTimer (FormPtr frm, int mode) {
void            *s;
ControlPtr      ctl;
ListPtr         lst;
FieldPtr        fld;
struct sTimers  *ptr;
int             i, j;

  TimCnt=Tflag=0;
  while (TimCnt<DmNumRecords (TimersDB) && TimCnt<TimeMax) {
    ptr=MemHandleLock (DmQueryRecord (TimersDB, TimCnt));
    StrCopy (Tnames[TimCnt],ptr->name);
    MemPtrUnlock (ptr);
    TimCnt++;
  }
  if (TimCnt && TimPos>=TimCnt) TimPos=TimCnt-1;
  if (TimCnt) {
    s=MemHandleLock (DmQueryRecord (TimersDB, TimPos));
    MemMove (&Timers, s, sizeof (Timers));
    MemPtrUnlock (s);
  } else
    MemSet (&Timers, sizeof (Timers), 0);
  if (mode) {
    LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_list)), Tnames, TimCnt);
    LstSetSelection (lst, TimPos);
    CtlSetLabel (ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_trig)), Timers.name);
  }
  Ttime=3*(Ptime=Timers.pause);
  for (i=0; i<4; i++)
    Ttime+=(Timers.time[i][Ttotal].len*((i)?100L:(100L+Prefs.Tmod)))/100;
  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, dev_desc)), Timers.note[0]);
  FldDrawField (fld);
  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, stop_desc)), Timers.note[1]);
  FldDrawField (fld);
  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, fix_desc)), Timers.note[2]);
  FldDrawField (fld);
  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, bath_desc)), Timers.note[3]);
  FldDrawField (fld);
  StrIToA (modif, Prefs.Tmod);
  StrCat (modif, "%");
  CtlSetLabel (ctl=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, time_mod)), modif);
  CtlDrawControl (ctl);
//  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, time_mod)), modif);
//  FldDrawField (fld);
}

// saves timer to database
static void SaveTimer (void) {
void *ptr;
  if (TimPos>=TimCnt) ptr=MemHandleLock (DmNewRecord (TimersDB, &TimPos, sizeof (Timers)));
  else ptr=MemHandleLock (DmGetRecord (TimersDB, TimPos));
  DmWrite (ptr, 0, &Timers, sizeof (Timers));
  MemPtrUnlock (ptr);
  DmReleaseRecord (TimersDB, TimPos, true);
}

// converts time to string
static void TimeToStr (char *s, UInt32 time, Boolean rel) {
  if (rel && time&0x80000000) time=-time;
  time%=86400;
  if (time>3600) {
    *s='0'+time/36000; time%=36000; s++;
    *s='0'+(time%36000)/3600; s++;
    *s=':'; s++;
  }
  *s='0'+(time%3600)/600; s++;
  *s='0'+(time%600)/60; s++;
  *s=':'; s++;
  *s='0'+(time%60)/10; s++;
  *s='0'+time%10; s++;
  *s='\0';
}

// prints actual time and all timers
static void ShowTime (FormPtr frm, int mode) {
FieldPtr        fld;
  TimeToStr (timeT, Ttime, true);
  TimeToStr (timeP, Ptime, true);
  TimeToStr (RTC, TimeNow, false);
  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_main)), timeT);
  if (mode) FldDrawField (fld);
  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_beep)), timeP);
  if (mode) FldDrawField (fld);
//  FrmSetTitle (frm, RTC);
  FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_time)), RTC);
  if (mode) FldDrawField (fld);
}

void SetAlerts (void) {
Int16 T;
// in case of modify total time only (leave time between alerts unchanged) multiply Ttime only here
  Ttime=Timers.time[Ttype][Ttotal].len;
  if (!Ttype && !Tincl) Ttime=(Ttime*(100L+Prefs.Tmod))/100;
  T=0;
  Ppos=0;
  while (T<Timers.time[Ttype][Tbegin].cnt*Timers.time[Ttype][Tbegin].len && T+Timers.time[Ttype][Tbegin].len<Ttime) {
    T+=Timers.time[Ttype][Tbegin].len;
    Ptimes[Ppos]=Ttime-T;
    Ppos++;
  }
  if (Timers.time[Ttype][Tmid].len) {
    while (Ttime-T-Timers.time[Ttype][Tmid].len>Timers.time[Ttype][Tend].cnt*Timers.time[Ttype][Tend].len) {
      T+=Timers.time[Ttype][Tmid].len;
      Ptimes[Ppos]=Ttime-T;
      Ppos++;
    }
  }
  T=Timers.time[Ttype][Tend].cnt;
  while (T) {
    Ptimes[Ppos]=Timers.time[Ttype][Tend].len*T;
    T--;
    Ppos++;
  }
  Ptimes[Ppos]=0;
// multiply Ttime (if ist is not multiplied yet) and Ptime by modification number
  if (!Ttype && Tincl) {
    Ttime=(Ttime*(100L+Prefs.Tmod))/100;
    for (T=0; T<Ppos; T++) Ptimes[T]=(Ptimes[T]*(100L+Prefs.Tmod))/100;
  }
  Ptime=Ttime-Ptimes[Ppos=0];
}

// prints button's label depending on timer state
static void ShowState (FormPtr frm) {
  CtlSetLabel (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_start)), TmrModes[(!Tflag)?0:((Tflag&0x80)?5:Ttype+1)]);
}

// main event handler
static Boolean MainEventHandler (EventPtr event) {
FormPtr         frm, newfrm;
int             handled = 0;
FontID          oldFont;
ControlPtr      ctl;
FieldPtr        fld;
ListPtr         lst;
char            value[16], *EVT;
Int32           vals[3], d;
int             i;
int             coef[11]={100, 107, 115, 123, 132, 141, 152, 162, 174, 187, 200};
SndCommandType  sndcmd;
EventType       nevent;

  frm = FrmGetActiveForm ();
//  frm=FrmGetFormPtr (main_form);
  switch (event->eType) {
// form events
    case frmOpenEvent:
      LoadTimer (frm, 1);
      TimeNow=TimGetSeconds ();
      ShowTime (frm, 0);
      FrmDrawForm (frm);
      frm_win=WinGetDrawWindow ();
      handled = 1;
      break;
    case appStopEvent:
    case frmCloseEvent:
//      FrmDeleteForm (frm);
      break;
// control select events
    case ctlSelectEvent:  // A control button was pressed and released.
      switch (event->data.ctlEnter.controlID) {
	case timer_start:
	  handled=1;
	  if (!Tflag) { // START
	    Ttype=0;
	    SetAlerts ();
	    Tflag=1;
	  } else Tflag^=0x80;
	  if (!(Tflag&0x80)) LastTime=TimGetSeconds ();
	  ShowState (frm);
	  break;
	case timer_reset:
	  Tflag=0;
	  LoadTimer (frm, 1);
	  ShowTime (frm, 1);
	  ShowState (frm);
	  handled=1;
	  break;
	case time_mod:
	  goto ModifyTime;
	  break;
      }
      break;
// menu events
    case menuEvent: // menu item was selected
      switch (event->data.menu.itemID) {
      case menu_about:
	FrmHelp (str_about);
	break;
      case menu_new:
	TimPos=TimCnt;
	MemSet (&Timers, sizeof (Timers), 0);
	DmWrite (EVT=MemHandleLock (DmNewRecord (TimersDB, &TimPos, sizeof (Timers))), 0, &Timers, sizeof (Timers));
	MemPtrUnlock (EVT);
	DmReleaseRecord (TimersDB, TimPos, true);
	LoadTimer (frm, 0);
      case menu_edit:
	if (!TimCnt) break;
	FrmGotoForm (edit_form);
	break;
      case menu_remove:
	if (!TimCnt) break;
	if (FrmAlert (delete_alert)) break;
	DmRemoveRecord (TimersDB, TimPos);
	if (TimCnt && TimPos>=TimCnt) TimPos=TimCnt-1;
	LoadTimer (frm, 2);
	break;
      case menu_modify:
	MenuEraseStatus (NULL);
	ModifyTime:
	newfrm=FrmInitForm (modify_form);
	StrIToA (MemHandleLock (valueHnd), Prefs.Tmod); MemHandleUnlock (valueHnd);
	FldSetTextHandle (fld=FrmGetObjectPtr (newfrm, d=FrmGetObjectIndex (newfrm, modify_num)), (Handle)valueHnd);
	FldSetSelection (fld, 0, StrLen (MemHandleLock (valueHnd))); MemHandleUnlock (valueHnd);
	CtlSetValue (ctl=FrmGetObjectPtr (newfrm, FrmGetObjectIndex (newfrm, modify_alert)), Tincl);
	FrmDrawForm (newfrm);
	FrmSetFocus (newfrm, d);
	i=FrmDoDialog (newfrm);
	FldSetTextHandle (fld, NULL);
	if (i==modify_ok) {
	  Tincl=CtlGetValue (ctl);
	  Prefs.Tmod=StrAToI (MemHandleLock (valueHnd)); MemHandleUnlock (valueHnd);
	  LoadTimer (frm, 0);
	}
	FrmDeleteForm (newfrm);
      }
      handled = 1;
      break;
// list select events
    case popSelectEvent: // listbox item selection
      switch (event->data.popSelect.listID) {
	case timer_list:
	  TimPos=event->data.popSelect.selection;
	  Tflag=0;
	  Prefs.Tmod=0;
	  ShowState (frm);
	  LoadTimer (frm, 2);
	  ShowTime (frm, 1);
	  handled=1;
	  break;
      }
      break;
// timer update
    case nilEvent:
      TimeNow=TimGetSeconds ();
      if (Tflag && !(Tflag&0x80)) {
	if (TimeNow>LastTime) {
	  Ttime--; Ptime--;
	  LastTime++;
	  if (Tflag==1 && (Ttime==Ptimes[Ppos] || Ttime<Timers.alert)) {
	    sndcmd.cmd=sndCmdFrqOn;
	    sndcmd.param1=440*(Ttype+1);
	    sndcmd.param2=(Ttime)?50:500;
	    sndcmd.param3=sndMaxAmp;
	    SndDoCmd (NULL, &sndcmd, 0);
	    if (Ptimes[Ppos]) Ppos++;
	    Ptime=Ttime-Ptimes[Ppos];
	  }
	  if (!Ttime) {
	    if (Ttype<3) {
	      if (Tflag==1) {
		Tflag=2;
		Ttime=Ptime=Timers.alert;
	      } else {
		Ttype++;
		SetAlerts ();
		Tflag=1;
	      }
	    } else {
	      Tflag=0;
	      Ttype=0;
	      LoadTimer (frm, 0);
	    }
	    ShowState (frm);
	  }
	}
	EvtResetAutoOffTimer ();
      }
      if (WinGetDrawWindow ()==frm_win) ShowTime (frm, 1);
      break;

  }
  return handled;
}

void LoadEdit (FormPtr frm) {
UInt16  idx;
char    *s;
  StrCopy (MemHandleLock (fieldtext), Timers.name); MemHandleUnlock (fieldtext);
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_name)), (Handle)fieldtext);
  StrCopy (MemHandleLock (notehnd), Timers.note[Ttype]); MemHandleUnlock (notehnd);
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_note)), (Handle)notehnd);
  StrIToA (MemHandleLock (paushnd), Timers.pause); MemHandleUnlock (paushnd);
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_pause)), (Handle)paushnd);
  StrIToA (MemHandleLock (alerthnd), Timers.alert); MemHandleUnlock (alerthnd);
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_alert)), (Handle)alerthnd);
  for (idx=0; idx<Tcnt; idx++) {
    if (idx==0 || idx==2) {
      s=MemHandleLock (setup[idx][0]); *s='\0';
      if (Timers.time[Ttype][idx].cnt) StrIToA (s, Timers.time[Ttype][idx].cnt);
      MemHandleUnlock (setup[idx][0]);
      FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_cnt0+idx)), (Handle)setup[idx][0]);
    }
    s=MemHandleLock (setup[idx][1]); *s='\0';
    if (Timers.time[Ttype][idx].len) StrIToA (s, Timers.time[Ttype][idx].len);
    MemHandleUnlock (setup[idx][1]);
    FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_len0+idx)), (Handle)setup[idx][1]);
  }
}

void SaveEdit (FormPtr frm) {
UInt16  idx;
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_name)), NULL);
  StrCopy (Timers.name, MemHandleLock (fieldtext)); MemHandleUnlock (fieldtext);
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_note)), NULL);
  StrCopy (Timers.note[Ttype], MemHandleLock (notehnd)); MemHandleUnlock (notehnd);
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_pause)), NULL);
  Timers.pause=StrAToI (MemHandleLock (paushnd)); MemHandleUnlock (paushnd);
  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, timer_alert)), NULL);
  Timers.alert=StrAToI (MemHandleLock (alerthnd)); MemHandleUnlock (alerthnd);
  for (idx=0; idx<Tcnt; idx++) {
    if (idx==0 || idx==2) {
      FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_cnt0+idx)), NULL);
      Timers.time[Ttype][idx].cnt=StrAToI (MemHandleLock (setup[idx][0])); MemHandleUnlock (setup[idx][0]);
    }
    FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_len0+idx)), NULL);
    Timers.time[Ttype][idx].len=StrAToI (MemHandleLock (setup[idx][1])); MemHandleUnlock (setup[idx][1]);
  }
}

// edit event handler
static Boolean EditEventHandler (EventPtr event) {
FormPtr         frm;
int             handled = 0;
UInt16          ID;

  frm = FrmGetActiveForm ();
//  frm=FrmGetFormPtr (edit_form);
  switch (event->eType) {
// form events
    case frmOpenEvent:
      Ttype=0;
      handled = 1;
      LoadEdit (frm);
      FrmDrawForm (frm);
      break;
    case frmCloseEvent:
//      FrmDeleteForm (frm);
      break;
// control select events
    case ctlSelectEvent:  // A control button was pressed and released.
      switch (event->data.ctlEnter.controlID) {
	case edit_ok:
	case edit_cancel:
	  SaveEdit (frm);
	  if (event->data.ctlEnter.controlID==edit_ok) SaveTimer ();
	  FrmGotoForm (main_form);
	  handled=1;
	  break;
      }
      break;
// list select events
    case popSelectEvent: // listbox item selection
      switch (event->data.popSelect.listID) {
	case edit_list:
	  SaveEdit (frm);
	  Ttype=event->data.popSelect.selection;
	  LoadEdit (frm);
	  FrmDrawForm (frm);
      }
      break;
// menu...
    case menuEvent: // menu item was selected
/*
      if ((ID=FrmGetFocus (frm))!=noFocus) {
	switch (event->data.menu.itemID) {
	  case menu_undo:
	    FldUndo (FrmGetObjectPtr (frm, ID));
	    break;
	  case menu_cut:
	    FldCut (FrmGetObjectPtr (frm, ID));
	    break;
	  case menu_copy:
	    FldCopy (FrmGetObjectPtr (frm, ID));
	    break;
	  case menu_paste:
	    FldPaste(FrmGetObjectPtr (frm, ID));
	    break;
	}
      }
//      handled=1;
*/
      break;
  }
  return handled;
}
